//-----------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include <stdio.h>
#include "PalMain.h"
//-----------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
struct { LOGPALETTE lp; PALETTEENTRY pe[255]; } Open, Save, Pal;
//-----------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner) : TForm(Owner)
{ Bitmap = new Graphics::TBitmap();
}
//-----------------------------------------------------------------
void __fastcall TForm1::FormDestroy(TObject *Sender)
{ delete Bitmap;
}
//-----------------------------------------------------------------
//  File|Open -  BMP     Open
void __fastcall TForm1::OpenItemClick(TObject *Sender)
{ if (OpenDialog1->Execute())
  { Bitmap->LoadFromFile(OpenDialog1->FileName);
    Bitmap->IgnorePalette = true;
    Image1->Canvas->Draw(0, 0, Bitmap);
    Grid1->Cells[0][0] = " Index";  Grid1->Cells[1][0] = "   Red";
    Grid1->Cells[2][0] = " Green";  Grid1->Cells[3][0] = "  Blue";
    Grid2->Cells[0][0] = " Index";  Grid2->Cells[1][0] = "   Red";
    Grid2->Cells[2][0] = " Green";  Grid2->Cells[3][0] = "  Blue";
    X1 = 0; X2 = 255;               SaveItem->Enabled = false;
    //    256    Open
    GetPaletteEntries(Bitmap->Palette,0,256, Open.lp.palPalEntry);
    Pal = Open;
    DrawGrid(Grid1);
    DrawGrid(Grid2);
    A1->Left = Arrows->Left - 7;
    A2->Left = Arrows->Left + 201;
  }
}
//-----------------------------------------------------------------
//      
void __fastcall TForm1::ArrowsDragOver(TObject *Sender,
    TObject *Source, int X, int Y, TDragState State, bool &Accept)
{
  if (Source == A1) X1 = X;
  if (Source == A2) X2 = X;
  DrawBitmap();
  Pal = Save;
  DrawGrid(Grid2);
  Grid1->Row = X+1;
  Grid2->Row = X+1;
}
//-----------------------------------------------------------------
//       
void __fastcall TForm1::ArrowsEndDrag(TObject *Sender,
    TObject *Target, int X, int Y)
{ if (Sender == A1) A1->Left = Arrows->Left + X1 - 7;
  if (Sender == A2) A2->Left = Arrows->Left + X2 - 7;
  SaveItem->Enabled = true;
}
//-----------------------------------------------------------------
//   Save       Image2
void __fastcall TForm1::DrawBitmap(void)
{ for (int X=0;  X<X1;  X++)
    Save.lp.palPalEntry[X] = Open.lp.palPalEntry[0];
  for (int X=X1; X<X2;  X++)
    Save.lp.palPalEntry[X] = Open.lp.palPalEntry[255*(X-X1)/(X2-X1)];
  for (int X=X2; X<256; X++)
    Save.lp.palPalEntry[X] = Open.lp.palPalEntry[255];
  unsigned char *RowPtr;
  for (int Y=0; Y<Bitmap->Height; Y++)
  { RowPtr = (unsigned char *)Bitmap->ScanLine[Y];
    for (int X=0;  X<X1;  X++) RowPtr[X] = 0;
    for (int X=X1; X<X2;  X++) RowPtr[X] = 255*(X-X1)/(X2-X1);
    for (int X=X2; X<256; X++) RowPtr[X] = 255;
  } Image2->Canvas->Draw(0, 0, Bitmap);
}
//-----------------------------------------------------------------
//        Grid
void __fastcall TForm1::DrawGrid(TStringGrid *Grid)
{ char s[8];
  for (int i=0; i<256; i++)
  { PALETTEENTRY pe = Pal.lp.palPalEntry[i];
    sprintf(s, "%6d", i);           Grid->Cells[0][i+1] = s;
    sprintf(s, "%6d", pe.peRed);    Grid->Cells[1][i+1] = s;
    sprintf(s, "%6d", pe.peGreen);  Grid->Cells[2][i+1] = s;
    sprintf(s, "%6d", pe.peBlue);   Grid->Cells[3][i+1] = s;
  }
}
//-----------------------------------------------------------------
//  File|Save -  BMP     Save
void __fastcall TForm1::SaveItemClick(TObject *Sender)
{ if (SaveDialog1->Execute())
  { Save.lp.palVersion = 0x300;     Save.lp.palNumEntries = 256;
    Bitmap->Palette = CreatePalette(&Save.lp);
    Bitmap->SaveToFile(SaveDialog1->FileName);
  }
}
//-----------------------------------------------------------------

