//-----------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include <math.h>
#include "Flying.h"
//-----------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TSkyForm *SkyForm;
const int Stars = 60;
struct { int r, dr, m; float sina, cosa; } StarTab[Stars];
//-----------------------------------------------------------------
__fastcall TSkyForm::TSkyForm(TComponent* Owner) : TForm(Owner)
{ W = ClientWidth;                  H = ClientHeight;
  X0 = W/2;                         Y0 = W/2;
  Application->OnIdle = &WhenIdle;  //    OnIdle
}
//-----------------------------------------------------------------
void __fastcall TSkyForm::FormCreate(TObject *Sender)
{ Skymap = new Graphics::TBitmap;
  Skymap->PixelFormat = pf8bit;     Skymap->IgnorePalette = true;
  Skymap->Width = W;                Skymap->Height = H;
  randomize();
  for (int s=0; s<Stars; s++)
  { StarTab[s].r = 0;
    StarTab[s].dr = 1+random(5);    StarTab[s].m = 1+random(5);
    StarTab[s].sina = sin(s*2*M_PI/Stars);
    StarTab[s].cosa = cos(s*2*M_PI/Stars);
  }
}
//-----------------------------------------------------------------
void __fastcall TSkyForm::WhenIdle(TObject *Sender, bool &Done)
{ Done = false;                     StarGenerator();
}
//-----------------------------------------------------------------
void __fastcall TSkyForm::StarGenerator(void)
{ W = ClientWidth;                  H = ClientHeight;
  Skymap->Width = W;                Skymap->Height = H;
  Skymap->Canvas->Brush->Color = clBlack;
  Skymap->Canvas->FillRect(Rect(0, 0, W, H));
  for (int s=0; s<Stars; s++)
  { //        
    StarTab[s].r += StarTab[s].dr;  int R = StarTab[s].r;
    int X = X0 + R*StarTab[s].sina; int Y = Y0 + R*StarTab[s].cosa;
    if ((X < 0) || (X >= W) || (Y < 0) || (Y >= H))
    { StarTab[s].r = 0 ; X = X0; Y = Y0; }
    //     
    Skymap->Canvas->Brush->Color = clWhite;
    Skymap->Canvas->Ellipse(X, Y, X+StarTab[s].m, Y+StarTab[s].m);
  }
  Canvas->Draw(0, 0, Skymap);       //   
  Caption = "   --   (" +
            IntToStr(X0-W/2) + ", " + IntToStr(H/2-Y0) + ")";
}
//-----------------------------------------------------------------
void __fastcall TSkyForm::FormResize(TObject *Sender)
{ W = ClientWidth;                  H = ClientHeight;
  X0 = W/2;                         Y0 = H/2;
}
//-----------------------------------------------------------------
void __fastcall TSkyForm::FormDestroy(TObject *Sender)
{ delete Skymap;
}
//-----------------------------------------------------------------
void __fastcall TSkyForm::FormMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{ X0 = X;                           Y0 = Y;
}
//-----------------------------------------------------------------
void __fastcall TSkyForm::FormMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{ if (Shift.Contains(ssLeft))
  { X0 = X;                         Y0 = Y; }
}
//-----------------------------------------------------------------

